import java.util.Arrays;

/** Insertion functions
 *  @author Josh Hug
 */

public class ArrayInsert {
	/** Inserts X into position K into A, pushing
	 *  everything over to the right one if necessary.
	 *  Whoever is on the end falls off, sry.
	 */
	public static void insert(String[] a, int k, String x) {
		/* Approach one: 
		   Move everything from k and on to one spot later
		*/

		for (int i = a.length - 1; i > k; i--) {
			a[i] = a[i - 1];
		}

		a[k] = x;
	}

    /** Inserts X into position K into A, pushing
     *  everything over to the right one if necessary.
     *  Whoever is on the end falls off, sry.
     */
    public static void insertAlternate(String[] a, int k, String x) {
        int numToCopy = a.length - k - 1;
        System.arraycopy(a, k, a, k + 1, numToCopy);
        a[k] = x;
    }

    /** Inserts X into position K into A by resizing
     */
    public static String[] insertResize(String[] a, int k, String x) {
        String[] ret = new String[a.length + 1];
        
        /* copy first k items */
        System.arraycopy(a, 0, ret, 0, k);
        ret[k] = x;

        /* copy last N - k items*/
        System.arraycopy(a, k, ret, k + 1, a.length - k);
        return ret;
    }

	/** Calls insertion functions
	 */

	public static void main(String[] args) {
		String[] input = {"fish", "never", "learned", "to", "swim"};

        insert(input, 2, "hats");
        insertAlternate(input, 2, "horse");
        System.out.println(Arrays.toString(input));

        String[] output = insertResize(input, 2, "hats");
        System.out.println(Arrays.toString(output));

    }
} 